========================================================
(C)1993, 1994, 1995 Institute for New Generation Computer Technology
(配布その他は COPYRIGHT ファイルを参照して下さい.)
(C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
(配布その他は COPYRIGHT-JIPDEC ファイルを参照してください)
========================================================

KL1 から C へのコンパイラシステム: KLIC (3.002版)
====================================================
1996年9月17日改訂
東京大学                            近山 隆
(株) 三菱総合研究所                 藤瀬 哲朗
                                    関田 大吾

[1] KLIC とは

KLIC は並行論理型言語 KL1 の処理系です.  KL1 は Guarded Horn Clauses
(GHC) のフラット版に基づいた言語です.  GHC はいわゆる committed-choice 
型の並行論理型言語族の一員で, Concurrent Prolog, Parlog, Janus, Fleng 
などの兄弟にあたります.

KLIC 処理系は, KL1 プログラムを C プログラムにコンパイルし, それをホス
トシステムの C コンパイラでコンパイルし, 実行時ライブラリ (UNIX が提供
するものを含む) とリンクして実行する, という方式をとっています.

今回の配布では二種類の並列実装が付け加わりました.  ひとつは分散メモリ実
装と呼ばれ, 現バージョンでは PVM(Parallel Virtual Machine) というプロ
セス間通信ライブラリを必要としています.  もう一方は, SparcCenter, DEC
Alpha 上での共有メモリ実装です。


	KLIC --+-- 逐次実装
	       |
	       +-- 並列実装 ---+--- 分散メモリ
	                       |
	                       +--- 共有メモリ

注意:

現在、共有メモリ実装でいくつかの深刻なバグがみつかっており、将来の版で
修正されます。2.00x版の共有メモリ実装を現在利用されている場合には、こ
の版と置きかえることはやめてください。

[2] 実行環境

KL1 プログラムを C プログラムに翻訳するコンパイラは KL1 自身で書いてあ
ります.  配布には C にコンパイル済みのコンパイラと KL1 ソースの両方が
入っています.

KLIC コンパイラでコンパイルした KL1 プログラムは, さらに C コンパイラ
でコンパイルし, KLIC 実行時ライブラリおよび UNIX が提供するライブラリ
とリンクする必要があります.

KLIC システムは多くの UNIX システムに移植できるようにしたつもりですが,
現版には若干のシステム依存性が残っているようです.

現版は以下の UNIX システムでは動作を確認しています.

逐次実装：

	IBM PC/AT compatible running Linux 2.0.x
		with gcc-2.7.x
	IBM PC/AT compatible running FreeBSD 2.2.1-RELEASE
		with gcc-2.7.2
	IBM PC/AT compatible running Solaris 2.5.x
		with Sun SPARCompiler
	Sun SparcStation 10 running SunOS 4.1.3
		with gcc-2.7.x and cc
	Sun SparcStation 20 running SunOS 4.1.4
		with gcc-2.7.2
	Sun SparcStation 20 running SunOS 5.4
		with gcc-2.7.2 and SPARCompiler
	SparcCenter 2000 running SunOS 5.3 (Solaris 2.3)
		with gcc-2.7 and SunC 2.0.1
	Ultra Enterprise 3000 running SunOS 5.5.1
		with gcc-2.7.2.2
	SGI Indigo2 IMPACT running IRIX 5.3 *
		with cc
	IBM RS6000 running AIX *
		with cc

	その他

*: 現在の版では未確認ですが、過去の版で動作していることは確認されてお
り、まず問題なく動作すると考えられます。

並列実装：

NOTE: 今回の配布では、致命的なバグが共有メモリ版では発見されています。
2.x版の共有メモリ実装を利用されている場合には置きかえることは避けてく
ださい。

・分散メモリ実装には、さらに以下のようなバリエーションがあります。

	a) "pvm" 版: この版は以前からの分散バージョンと互換のものです。
	全ての通信はPVMを経由して行なわれます。

	b) "pvm-tcp" 版: この版では通信はTCP-IPのsocketを経由して行な
	われます。システムの初期化のためにPVMを利用しているため、以前
	としてPVMが必要です。

	c) "shm" 版: この版では全てのプロセッサ間通信は共有メモリを用
	いて行なわれます。ただし、この版は「共有メモリ」版とは別の版で
	あり、KL1データをそのまま共有メモリに置き通信をするのではあり
	ません。よって、真の「共有メモリ版」よりも効率は落ちます。この
	版にはPVMは必要ありません。

効率的にはshm版が最も良いと考えられ、pvm版がもっとも悪いと考えられます。
一方移植性に関してはshmが悪く、以下のプラットフォームでしか動作確認さ
れておらず、他の計算機(特にプロセッサの異なる計算機)への移植は手間がか
かるものと思われます。

	SparcCenter 2000 running SunOS 5.3 (Solaris 2.3)
		with gcc-2.7.0
	Ultra-Enterprise running SunOS 5.5.1 (Solaris 2.5.1)
		with gcc-2.7.2.1
	DEC 7000 AXP running OSF1
		with gcc-2.7
	IBM PC/AT compatible multi processor machine running Linux 2.0.x
		with gcc-2.7

"pvm"版は移植性は良いと考えられるので、もしも、ここに挙げられたような
プラットフォーム以外で実行をこころみるならば、最初に"pvm"版を試みてく
ださい。

もし上記のシステム以外でうまくインストールできたら, あるいはインストー
ルがうまくいかなかったら, 以下のアドレスに御連絡いただければ幸いです。

	klic@icot.or.jp

[3] ドキュメント

システムの texinfo 形式の日本語と英語の簡単なマニュアルが配布に含まれ
ています.  ただし日本語のマニュアルは klic-1.600 版に対応したもので, 
最新版ではないことにご注意下さい.  マニュアルのソースとフォーマット済
みの info と dvi の形式のファイルがディレクトリ "documents" の下にあり
ます.

[4] ファイル

ファイルについては MANIFEST と御覧下さい.

[5] インストール

実行時システムのインストールには KLIC システムのルートにある Configure 
スクリプトを走らせ, 次いで "make" を走らせるだけで良いはずです.  詳細
については INSTALL を御覧下さい.

[6] 提供機能

KLIC では KL1 プログラムの基本的な実行ができます.

基本部分以外に現在提供している機能は概略以下の通りです.

  - 若干の組込述語 (整数, 浮動小数点数についての算術演算など)
  - 文字列, 配列などのデータ構造と基本操作
  - トレーサ (ステップ実行, スパイ機能など)
  - ソケットの非同期入出力を含む入出力 (ホストによっては未提供)
  - 優先度制御機能
  - 並列実行機能

[7] バグについて

  - 日本語マニュアルは klic-2.0 版に対応してません.

  - マニュアルはまだ不完全です.

  - 並列版はまだ不完全なものです.

  - 当然必要な機能で未提供のものが数多くあります.

  - 他にも多数のバグがあるに違いありません.

バグ報告やコメントは下記のアドレスにお送り下さい.

	klic-bugs@icot.or.jp

見つけたバグや不具合は是非お知らせ下さい.  すべてのユーザのための次版
以降の改良のためにたいへん大事な情報です.

[8] 通知と情報交換

バグ, バグ修正, 新版の提供などの通知は下記のメイリングリストを通じて行
ないます.

	klic-users@icot.or.jp

このメイリングリストはユーザ間の情報交換にも使えます.

メイリングリストへの登録や抹消のためには以下のアドレスにメイルをお送り
下さい.

	klic-requests@icot.or.jp
